=== debian/changelog ===
libapache2-mod-tile (0.8.1-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 10 Aug 2025 11:13:47 +0200

libapache2-mod-tile (0.8.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 05 May 2025 05:58:58 +0200
